/* This is the core Steensgaard's Algorithm.                 */
/* It is a straightforward implementation of the pseudo-code */
/*    by Prof Pingali and Milind Kulkarni                    */
/* With some fixes provided by                               */
/*    Yulei Sui <ysui _at_ cse.unsw.edu.au>                  */

#include <stdio.h>
#include "node.h"
#include "union_find.h"


   /* Handles the x=&y case */
void equals_amp(struct node *x,struct node *y) {
   
   if (pt(x)==NULL) {
      x->points_to=rep_(y);
   }
   else rec_union(pt(x),y);
}
   
   /* Handles the x=y case */
void equals(struct node *x,struct node *y) {
   
   if ((pt(x)==NULL) && (pt(y)==NULL) ) {
      x->points_to=make_dummy();
   }
   
   y->points_to=(rec_union(pt(x),pt(y)));

}

   /* Handles the x=*y case */
void equals_star(struct node *x,struct node *y) {

   struct node *temp_node;
   
   if (pt(y)==NULL) {
      y->points_to=make_dummy();
   }
   
   temp_node=pt(y);
   
   if (pt(temp_node)==NULL) {
      rep_(temp_node)->points_to=make_dummy();
   }
   x->points_to=rec_union(pt(x),pt(temp_node));
}

   /* handles the *x=y case */
void star_equals(struct node *x,struct node *y) {

   struct node *temp_node;

   if (pt(x)==NULL) {
      x->points_to=make_dummy();
   }
   
   temp_node=pt(x);
   
   if (pt(temp_node)==NULL) {
      rep_(temp_node)->points_to=make_dummy();
   }
   
   y->points_to=rec_union(pt(y),pt(temp_node));
}
